#include "Voiture_Robobox.h"
Voiture::Voiture(int pin1MoteurG,
                 int pin2MoteurG,
                 int pinPMoteurG,
                 int pin1MoteurD,
                 int pin2MoteurD,
                 int pinPMoteurD)
{
  pinMode(pin1MoteurG,OUTPUT);
  pinMode(pin2MoteurG,OUTPUT);
  pinMode(pinPMoteurG,OUTPUT);
  pinMode(pin1MoteurD,OUTPUT);
  pinMode(pin2MoteurD,OUTPUT);
  pinMode(pinPMoteurD,OUTPUT);
  _pin1MoteurG=pin1MoteurG;
  _pin2MoteurG=pin2MoteurG;
  _pinPMoteurG=pinPMoteurG;
  _pin1MoteurD=pin1MoteurD;
  _pin2MoteurD=pin2MoteurD;
  _pinPMoteurD=pinPMoteurD;
}

void Voiture::dirMoteurG(int sensG,int pourcentageG)
{
  if (sensG==1){etat1=1; etat2=0;}
  else if (sensG==-1){etat1=0; etat2=1;}
  else {etat1=0; etat2=0;}
  puissance=map(pourcentageG,0,100,0,255);
  analogWrite(_pinPMoteurG,puissance);
  digitalWrite(_pin1MoteurG,etat1);
  digitalWrite(_pin2MoteurG,etat2);
}

void Voiture::dirMoteurD(int sensD,int pourcentageD)
{
  if (sensD==1){etat1=1; etat2=0;}
  else if (sensD==-1){etat1=0; etat2=1;}
  else {etat1=0; etat2=0;}
  puissance=map(pourcentageD,0,100,0,255);
  analogWrite(_pinPMoteurD,puissance);
  digitalWrite(_pin1MoteurD,etat1);
  digitalWrite(_pin2MoteurD,etat2);
}

void Voiture::bouge(int vit1 , int vit2)
{
  Vit_M_G = 0;
  Vit_M_D = 0;

  if (vit1 <3){
      tempVit = map(vit1, 2, 0, 20, 70);
      Vit_M_G = tempVit;
      Vit_M_D = tempVit;
  }
  else if (vit1 >5){
      tempVit = map(vit1, 6, 9, 20, 70);
      Vit_M_G = -tempVit;
      Vit_M_D = -tempVit;
  }
  
  if (vit2 <3){
      tempVit = map(vit2, 2, 0, 20, 70);
      Vit_M_G = Vit_M_G + tempVit;
      Vit_M_D = Vit_M_D - tempVit;
  }
  else if (vit2 >5){
      tempVit = map(vit2, 6, 9, 20, 70);
      Vit_M_G = Vit_M_G - tempVit;
      Vit_M_D = Vit_M_D + tempVit;
  }
  Vit_M_G = min(Vit_M_G,100);
  Vit_M_D = min(Vit_M_D,100);

  if (Vit_M_G<0) {Voiture::dirMoteurG(-1,-Vit_M_G);}
  else {Voiture::dirMoteurG(1,Vit_M_G);}

  if (Vit_M_D<0) {Voiture::dirMoteurD(-1,-Vit_M_D);}
  else {Voiture::dirMoteurD(1,Vit_M_D);}     
}

void Voiture::avance(int vitesse){
    Voiture::dirMoteurG(1,vitesse); 
    Voiture::dirMoteurD(1,vitesse); 
}

void Voiture::recule(int vitesse){
    Voiture::dirMoteurG(-1,vitesse); 
    Voiture::dirMoteurD(-1,vitesse);
}

void Voiture::tourneDroite(int vitesse){
    Voiture::dirMoteurG(1,vitesse);
    Voiture::dirMoteurD(-1,vitesse);
}

void Voiture::tourneGauche(int vitesse){
    Voiture::dirMoteurG(-1,vitesse); 
    Voiture::dirMoteurD(1,vitesse);
}

void Voiture::stop(){
    Voiture::dirMoteurG(0,0); 
    Voiture::dirMoteurD(0,0); 
}
