#ifndef Voiture_h

 #define Voiture_h

 #include <Arduino.h>

 class Voiture
 {
  public:
    Voiture(
        int pin1MoteurG,
        int pin2MoteurG,
        int pinPMoteurG,
        int pin1MoteurD,
        int pin2MoteurD,
        int pinPMoteurD);
   
    void bouge(int vi1 , int vit2);
    void avance(int vitesse);
    void recule(int vitesse);
    void tourneDroite(int vitesse);
    void tourneGauche(int vitesse);
    void stop();

  private:
    int puissance, Vit_M_G, Vit_M_D;
    int tempVit, etat1, etat2;
    int _pin1MoteurG, _pin2MoteurG;
    int _pinPMoteurG, _pin1MoteurD;
    int _pin2MoteurD, _pinPMoteurD;
    void dirMoteurG(
        int sensG,
        int pourcentageG);
    void dirMoteurD(
        int sensD,
        int pourcentageD);
 };   
#endif